Added Dimension Software                  (214) 341-5759
6780 Abrams Rd.                           CompuServ ID: 73311,1062
Suite 103-190                             Internet: 73311,1062@compuserve.com
Dallas, TX 75231


----------------------------------------------------------------------------
                        GoHome - Version 1.2
----------------------------------------------------------------------------

 This file contains information to help you get started using GoHome and 
 also contains last minute details that didn't make it into the documentation.

 The shareware version of GoHome is not "crippled" nor "limited" in any way.
 We wanted to make sure that you could evaluate it fully. The shareware
 version does have "UNREGISTERED" displayed in a few places and when
 GoHome is started, it displays a signon on banner and requires you to 
 press "G" to continue. When you register, you'll get a new version that
 doesn't contain these, as well as a printed tutorial and reference 
 manual.

 We've put a lot of time and effort into making GoHome a high quality 
 product. We welcome any comments, requests, or suggestions for additional 
 features that you may have.



   Contents
----------------------------------------------------------------------------
   + Quick Start
   + What's New in Version 1.2?
   + What's New in Version 1.1?
   + What is GoHome?
   + Tutorial
   + Installing GoHome
   + Running GoHome
   + Miscellaneous Notes
   + Using scripts to run disk defragmentors and similar programs
   + Running Under Windows, NT, and OS/2
   + Trouble Shooting
   + Error Messages
   + Revision History



****************************************************************************
                       Q u i c k    S t a r t
****************************************************************************

   GoHome does not require any special installation nor does it
   it require any modification to your CONFIG.SYS or AUTOEXEC.BAT files.
   If you recieved GoHome as an archive file (ie. GOHOME.ZIP), all you
   need to do is create a directory for it and extract all the files.
   
   To get an idea of some of the things that GoHome is capable of doing,
   type GODEMO at a DOS prompt. GODEMO loads GoHome and uses its abilities
   to "automate" tasks, to automate itself! The demo will take you through
   the major components of GoHome. To abort the demo, wait until a menu
   or window is not displayed and then press and hold the <Ctrl> key and
   then press the <Space bar> (this is GoHome's default hot-key). When a 
   menu apprears, release both keys. The demo requires that it be started 
   in the same directory as GoHome.

   Try running GODEMO2.BAT. This will run a GoHome script that shows off 
   some of GoHome's special script commands.



-----------------------------------------------------------------
   What's New in Version 1.2 ?
 
   Version 1.2 adds a number of commands to deal with files and directories.
   
   The following script commands have been added.
   
   *  FileCompare
   
      The FileCompare command is used to compare the contents of
      any two files. In order for the two files to be equal, they
      must contain exactly the same data and be the same length.

      The most common use for this command is to compare two screen
      shots. For example, you may need to take some action if a 
      particular error dialog box appears while your program is
      running. To do this, create a script that uses the 
      TakeSnaphot command (see the sample tutorial script file, 
      EXAMPLE4.SCR) to save just the portion of the screen 
      containing the error dialog. Then in your script, use the
      TakeSnapshot command again (specify the exact coordinates)
      to save the section of screen where the dialog appears to a 
      different file. If the two files contain the same screen 
      image, FileCompare will set the Result variable
      to OK.


      Result variable is set to: 
              OK       : if the contents match exactly
              Not OK   : if contents of files differ
              
      Example:

        TakeSnaphot | r=5 c=10 w=40 h=6 attrs=1 i=0 file=tst.snp
        FileCompare | errdlg.snp and tst.snp
             IfGoto | If Result is Equal to/than Ok then goto ERR
             
                ...
                
              Label | ERR
                ... handle error ...

  * FileDelDir
  
    The FileDelDir command will remove a specified directory.
    The directory must already be empty before it can be deleted.
    You should enter the complete path of the directory.


    Result variable is set to: 
            OK       : if directory was deleted
            Not OK   : if directory could not be deleted

  * FileDelete

    The FileDelete command will delete a specfied file. Note: wildcard
    characters ('*', '?') are not valid.

    Result variable is set to: 
            OK       : if the file was deleted.
            Not OK   : if the file could not be deleted.

  * FileExist
  
    The FileExist command is used to test if a file already
    exists.

    Result variable is set to: 
            OK       : if the file exists.
            Not OK   : if the file does not exist.

  * FileMakeDir
    The FileMakeDir command will create a new directory.

    Result variable is set to: 
            OK       : if the contents match exactly
            Not OK   : if contents of files differ
            
  * FileRename
  
    The FileRename command will rename a file.
    If a file with the new name exists, FileRename will
    fail and the file will not be renamed.

    Result variable is set to: 
            OK       : if the file was renamed.
            Not OK   : if the file could not be renamed.

-----------------------------------------------------------------
   What's New in Version 1.1 ?

   Version 1.1 adds a couple of new script enhancements. 

   You can use the new counting variable to perform looping iterations, 
   as well as simple mathematical expressions (+, -, /, *). The "Copy"
   command has been expanded to allow the counting variable's (named "Count")
   value to be set and retrieved. The "IfGoto" command has similarly been
   expanded to allow the value of "Count" to be tested.

   A new command, "Disable Keys", has been added. "Disable Keys" is used
   to enable/disable GoHome's hot-key, the reboot keys (<Ctrl><Alt><Del>), 
   and ALL other keys. This command is useful when running demos or
   when the script gets to a critical section that should not be interrupted.
      
   To get an idea of how these new commands may be used, try running 
   GODEMO2.BAT. Select one of the following options from the menu:

     Menu Item          Description
   ---------------------------------------------------------------------
    Simple Calculator   A prompt window will be displayed. In the edit box,
                        enter a mathematical expression (ie. 2300*43 / 3 + 9).
                        The result will be displayed in the top-left corner
                        of the screen.

    Count 1             This script shows how to perform a "while" type loop.
                        The first Copy initializes the Count variable to 1.
                        The IfGoto will jump to the end when Count equals 26.
                        Then, Count is written out to the file "tstcnt.out".
                        Count is then incremented by 1. After running,
                        look at file "tstcnt.out"

   Count 2              This script is similiar to Count 1 above but it 
                        shows how to save Count to an environment variable, 
                        use it for something else, and then restore it.                              

   Disable Keys         The script uses the "Disable Keys" command to 
                        disable GoHome's hot-key for 5 seconds, then disables
                        <Ctrl><Alt><Del> for 5 seconds, and finally, disables
                        all keys except for GoHome's hot-key.

   Time                 Display the current time at the top-left corner
                        of the screen. The time is updated every second.
                        Note that the script can run in the background
                        even while you use another program! Try it! When
                        you're done, press GoHome's hot-key (<Ctrl><Space>,
                        and select "Abort".


-----------------------------------------------------------------
   What is GoHome?

   GoHome is a set of utility programs that are designed to be easy to
   use and allow you to get more productivity from your computer.  With
   GoHome, you will be able to run tasks unattended at a time when the
   PC is otherwise going to be idle. Take advantage of lower phone rates
   for uploading/downloading of files and messages, print documents at 
   night when the printer isn't in use, schedule backup programs to run
   when you're not around, network administration tasks, and more. 
   GoHome's scripts can even be used to create working demos and tutorials, 
   or perform regression tests, or as an every day Super Macro Recorder 
   and Player!

   If you are using your computer when a scheduled task is to occur,
   GoHome will display a message and give you 15 seconds to either run
   the task, cancel it, or "snooze" it to have it run later. If you let
   the task continue, GoHome will save the state of your computer and
   restore it when the task is finished. Tasks do not necessarily have
   to be scheduled. They can be executed at any time with just a press
   of a couple of keys. This allows you to essentially make any program
   a TSR that can be popped up over a running application!

   GoHome can "learn" how to run programs that require user interaction.
   For more demanding applications, GoHome includes a unique script
   editor that is very easy to use and does not require you to learn 
   or memorize complex commands and their syntax. The script editor
   allows scripts to be modified and enhanced with a number of different
   script commands and control flow logic. Context sensitive help is
   available at the touch of a key if additional information is needed.

   GoHome also includes a text editor that has several unique properties.
   The text editor is ideal for editing batch files and taking notes.
   It can be used with GoHome to provide a "pop-up" notepad editor. Text
   can also be displayed in different colors throughout the document.

   Perhaps best of all, GoHome is available as shareware. Shareware lets
   you try programs out before you have to buy them. This is a GREAT way
   to buy software because you can evaluate a program to make sure that
   it does what you want it to before ploping down your hard earned 
   money. Most shareware programs are a better value because they 
   eliminate most of the "middle" man costs and the costly packaging
   that is necessary in retail sales. If you find this software or
   other shareware programs useful, it is VERY IMPORTANT that you register
   the software with the author and to show support the shareware 
   marketing concept.

-----------------------------------------------------------------
   Tutorial

   GoHome comes with an excellant tutorial that is designed to get
   you up and using GoHome as quick as possible. It covers many of
   the ins-and-outs of using GoHome that may be difficult to pick
   up without the tutorial. It is strongly suggested that you print 
   it and take some time to go through it. To print it, type the 
   following at the DOS prompt.

        COPY TUTORIAL.TXT PRN

   NOTE: TUTORIAL.TXT contains some screen snapshots that use the IBM
   line-drawing characters. Some printers are not capable of printing
   these characters. If that is the case, the screen snapshots will
   not be very pretty.


-----------------------------------------------------------------
   Installing GoHome

   GoHome is very easy to install.

   1. Create a directory to contain GoHome. For example, if you want to
      put GoHome into a directory named "GOHOME" on your C: drive type 
      at the DOS prompt:

        MD C:\GOHOME

   2. If you received GoHome in a compressed format (usually .ZIP), 
      decompress GoHome by using the appropriate compress program 
      (ie. PKUNZIP). Copy the files to the directory created in step 1. 

        C:\GOHOME> PKUNZIP GOHOME.ZIP

   3. You may want to modify your AUTOEXEC.BAT file to include GoHome
      in you path statement. This way, you'll be able to run GoHome
      without having to enter the complete path. If you want to run
      GoHome all the time, add "GOHOME" to your AUTOEXEC.BAT file
      as one of the last programs to load.

   4. In order for GoHome to function properly, it is VERY IMPORTANT 
      that the COMSPEC environment variable be set to the path and name 
      of the command processor being used. This is usually COMMAND.COM 
      but may be NDOS.COM or 4DOS.COM. Veryify that a statement in your 
      AUTOEXEC.BAT file (if your using DOS 6.0 or greater, it may be in 
      your CONFIG.SYS file) similar to the following is present:

        SET COMSPEC=C:\DOS6\COMMAND.COM

   5. GoHome will occasionally need to create a couple of "swap" files 
      inorder to save the screen and memory images to disk. It will
      use the directory indicated by the TEMP or TMP environment 
      variables. If these are not set, it will use the directory where
      GoHome is located. If you do not have one of these variables set,
      add a line similar to:

        SET TEMP=C:\TEMP
     
      in your AUTOEXEC.BAT. If you do not have a temp directory, you can
      create one using the DOS 'MD' command (ie. "MD C:\TEMP").

   6. Example scripts from the tutorial are in a self-extracting archive
      named "EXAMPLES.EXE". To extract the examples, type "EXAMPLES" at
      the DOS prompt.
      

-----------------------------------------------------------------
   Running GoHome

   GoHome is a TSR program that must be loaded before programs
   can be scheduled and scripts played back. To start GoHome,
   from the DOS prompt type "GOHOME" followed by the Enter key.
   
   To run a simple DEMO of GoHome, type "GODEMO" at the DOS prompt.
   The demo was created using GoHome's script capabilities.


-----------------------------------------------------------------
   GoHome goes through the following steps when it runs a 
   scheuled task:

   1. If the previous task hasn't finished, wait until it does.

   2. If a user is typing, wait until he stops for a few seconds.

   3. Display the Count Down pop-up window. User can run the
      task immediately, "snooze" it (delay task for 15 mins),
      or cancel the scheduled task.

   4. If a non-scheduled program is currently running, swap it out
      to make room for the scheduled task. The program can be swapped
      to XMS, EMS, or a hard drive. If the task is a script and the
      "Start Script At DOS Prompt" option is NOT checked, any program
      running will not be swapped out. This allows scripts to be used
      as a super macro to automate a task inside the running program.

   5. Execute the task.

   6. If a program was swapped out, restore it.

   7. Add an entry to the log file that shows the start and end times
      for the task.

   NOTE: Scheduled tasks and scripts may be run manually at ANY time.


-----------------------------------------------------------------
   Miscellaneous Notes

   * There is not a limit to the size of a GoHome script. However,
     the script editor can only edit scripts that are smaller than
     35K. GoHome does not use any extra memory when running large
     scripts (it will read sections of the script into memory
     whenever it needs to). It is possible to create scripts greater
     than 35K by using the "ChainTo" command.

  *  If a script starts a program from the DOS command line and it
     has the "Wait for a DOS Prompt" option checked (in GoSched's
     "Options..." dialog), no other task is allowed to run UNTIL
     it gets back to the DOS prompt.

  *  TakeSnapshot and PutSnapshot can be used to create colorful
     and large windows that the script can display as it's running.
     For example, see the GODEMO script.

  *  To disable screen blanking, start GoHome with the command line
     option '/BLNK=0'. For example:

        C:> gohome /blnk=0

  *  If you're working on your computer when the task Countdown window
     pops-up, you may delay the task from running by pressing <S> to 
     "snooze" the task for 15 minutes. You may also press one of the
     numeric keys (1 thru 9) to delay the task that number of minutes.
     To delay the task for just 15 seconds, press zero (<0>).

  *  If you're having problems getting keys to play back successfully
     from a script you entered manually into the script editor, try 
     recording the keystrokes and inserting the recorded script into
     the other script (use the "File | Insert File" menu option in
     GoScript.


-----------------------------------------------------------------
   Using scripts to run disk defragmentors and similar programs

   If a script is used to run programs that potentially can move data
   stored on a disk (i.e. disk defragmentors) it is IMPORTANT that the
   script be less than 1000 bytes in size (use "dir" to verify). This
   is because GoHome reads in sections of a script in 1024 byte 
   increments. If the running program moves a section of the disk that
   contains the script, GoHome will end up reading garbage and will
   crash the system. Simialarly, GoHome will write log information to 
   the log file when the script completes. It is, therefore, important
   to make sure that the script completely exists the defragmentor before
   the script finishes. An other option would be to check the 
   "Don't log task" in GoSched's "Options..." dialog for the script task.

-----------------------------------------------------------------
   Running Under Windows, NT, and OS/2
        
   GoHome may or may not be able to run certain tasks in a DOS box on 
   Windows, Windows NT, and OS/2.  It will not swap out a
   program that is running in the same DOS box. Instead, it will wait
   until it is at the DOS prompt before running scheduled programs. The
   screen blanker will also be disabled.

   IMPORTANT: Do NOT start Windows while GoHome is loaded. Instead, 
   start GoHome in a DOS box.


-----------------------------------------------------------------
   TroubleShooting

*  After GoHome runs a program at the DOS prompt, a message box appears 
   saying that "A task is already running..." when GoHome's hotkey is 
   pressed.

   This situation occurs if GoHome is not able to determine when DOS is
   at the DOS prompt (it thinks that the program is still running). In
   this case, unload GoHome and start it up with the "/DPMTHD=1" command
   line option. If running GoHome in a DOS box under MS Windows, use
   COMMAND.COM as the command shell instead of using "/DPMTHD=1".


-------------------------------------------------------------------
  Error Messages

  GoHome displays error messages in a red (default color) dialog box
  that shows what type of error occured and gives an error number.
  The following table lists a few of the common error messages and
  what they mean. Negative error numbers are specific to GoHome and
  are used in the log file.

    Error #    Description
    -----------------------------------------------------------
     2         File not found - Verify that the file specified
               is correct. You should use a complete path when
               specifying file names.
     3         Path not found - Verify that the path entered
               is correct.
     4         Too many files open - Increase the "FILES=xx" 
               statement in your CONFIG.SYS file.
     5         File access violation - GoHome attempted to access
               a file that is currently being used by another
               program.

 
     -2        Script file was not found.
   -100        Task scheduled was aborted by user.
   -101        Not enough disk space available to swap out the 
               current program.
   -102        Task could not be started due to file i/o error, 
               graphics, etc.
   -103        Not able to swap out requested amount of memory.
   -104        Swap file could not be created.
   -105        Invalid data file.
   -106        GoHome was not able to restore the swapped
               out program (i.e. swap file could not be found).
   -107        GoHome is not able to swap out a program when
               it is running in a DOS box in MS Windows, or OS/2.

        
-------------------------------------------------------------------
  Revision History

  Version   Date     Cause
  ===================================================================
  1.00     4/30/94   Initial release
  1.00a    5/11/94   Improved ability to run demo off a CD-ROM
  1.00b    6/28/94   Fixed problem with PC occasionally locking up
                     when swapping to disk and neither TEMP or TMP
                     environment variables were set.
                     A script task with the countdown window option
                     turned off was getting scheduled twice.
  1.00c    7/08/94   Fixed a bug introduced in version 1.00b regarding
                     scripts started manually from GoHome's menu.
  1.10     10/07/94  Adds numeric variable and basic numerical functions,
                     +, -, *, and /. The IfGoto and Copy commands were
                     modified to support testing the variable, and
                     setting and retrieving its values, respectively.
                     A new command, "Disable Keys", was added to disable
                     and disable GoHome's hot-key, reboot keys, and all 
                     other keys. Some internal optimization was also done.
  1.10a   04/20/95   Minor changes.
  1.10b   06/01/95   Some systems were losing timer ticks which caused
                     GoHome to run "extra" events just before midnight.
                     This version will sync up these events.
  1.2     07/11/95   Adds a number of file related commands plus some
                     minor enhancements.

